/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlrechtspruefung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractPruefkriteriumSearch {

  @Inject
  protected transient PruefkriteriumExtendedDAO dao;

  public AbstractPruefkriteriumSearch() {
    super();
  }

  public List<Pruefkriterium> getSearchResult(PruefkriteriumSearchParameters searchParameters, EagerLoadingCollector<Pruefkriterium> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Pruefkriterium> querySearchResult(PruefkriteriumSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
